resource "gitlab_project_variable" "vault_addr" {
  count     = var.vault_addr != null ? 1 : 0
  project   = var.gitlab_project_id
  key       = "VAULT_ADDR"
  value     = var.vault_addr
  protected = true
}

resource "gitlab_project_variable" "vault_auth_role" {
  count     = var.vault_addr != null ? 1 : 0
  project   = var.gitlab_project_id
  key       = "VAULT_AUTH_ROLE"
  value     = local.vault_boundary_jwt_auth_backend_role
  protected = true
}

resource "gitlab_project_variable" "vault_auth_path" {
  project   = var.gitlab_project_id
  key       = "VAULT_AUTH_PATH"
  value     = var.vault_jwt_auth_backend_path
  protected = true
}

resource "gitlab_project_variable" "vault_namespace" {
  count     = var.vault_namespace != null ? 1 : 0
  project   = var.gitlab_project_id
  key       = "VAULT_NAMESPACE"
  value     = var.vault_namespace
  protected = true
}

resource "gitlab_project_variable" "vault_jwt_auth_backend_role_boundary_role_name" {
  project   = var.gitlab_project_id
  key       = "VAULT_JWT_AUTH_BACKEND_ROLE_BOUNDARY_ROLE_NAME"
  value     = vault_jwt_auth_backend_role.terraform_boundary.role_name
  protected = true
}
