resource "vault_policy" "terraform_boundary_controller" {
  name   = local.vault_boundary_controller_policy_name
  policy = <<EOF
path "/${var.vault_transit_secret_backend_path}/encrypt/boundary-recovery" {
  capabilities = ["update"]
}

path "/${var.vault_transit_secret_backend_path}/decrypt/boundary-recovery" {
  capabilities = ["update"]
}
EOF
}

resource "vault_jwt_auth_backend_role" "terraform_boundary_controller" {
  backend   = var.vault_jwt_auth_backend_path
  role_type = "jwt"

  role_name      = local.vault_boundary_jwt_auth_backend_role
  token_policies = ["default", vault_policy.terraform_boundary_controller.name]

  bound_claims = {
    project_id    = var.gitlab_project_id
    ref           = var.gitlab_branch
    ref_type      = "branch"
    ref_protected = "true"
  }

  bound_audiences = ["vault"]

  user_claim             = "iss"
  token_explicit_max_ttl = 900
}
